<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">
    <title>Image Classifier</title>
  </head>
  <body>
    <form id="image-form">
      <input type="file" name="image">
      <br><br>
      <select id="model-selector">
        <option value="inception">Inception v3</option>
        <option value="coco">COCO-SSD</option>
        <option value="knn">KNN Classifier</option>
        <option value="keras">Custom Keras Model</option>
      </select>
      <br><br>
      <button type="submit">Submit</button>
    </form>
    <br>
    <img id="image-preview" src="#" alt="Image Preview">
    <br><br>
    <div id="results"></div>
    <script>
      const form = document.getElementById('image-form');
      const imagePreview = document.getElementById('image-preview');
      const modelSelector = document.getElementById('model-selector');
      const results = document.getElementById('results');
      
      form.addEventListener('submit', async (e) => {
        e.preventDefault();
        results.innerText = 'Processing...';
        
        const formData = new FormData(form);
        const modelName = modelSelector.value;
        const response = await fetch('/set-model', {
          method: 'POST',
          headers: {
            'Content-Type': 'application/json'
          },
          body: JSON.stringify({ modelName })
        });
        if (!response.ok) {
          results.innerText = 'Error loading model';
          return;
        }
        
        const file = formData.get('image');
        if (!file) {
          results.innerText = 'No image selected';
          return;
        }
        
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onloadend = async () => {
        imagePreview.src = reader.result;
        
          const response = await fetch('/detect', {
            method: 'POST',
            body: formData,
            //body: JSON.stringify({ modelName })
          });
          if (!response.ok) {
            results.innerText = 'Error processing image';
            return;
          }
          const data = await response.json();
          
         if (data.diseases) {
            results.innerText = `Predicted diseases: ${data.diseases[0].disease};%`; 
          }else if (data.predictions){
          results.innerText = `Predictions: ${data.predictions[0].class}, Score: ${data.predictions[0].score}% `;
          
          // Draw the bounding boxes
          /*const canvas = document.createElement('canvas');
          canvas.width = imagePreview.width;
          canvas.height = imagePreview.height;
          const ctx = canvas.getContext('2d');
          ctx.drawImage(imagePreview, 0, 0);
          ctx.lineWidth = 3;
          ctx.strokeStyle = 'red';
          ctx.font = '18px Arial';
          ctx.fillStyle = 'red';
          for (const box of data.boxes) {
            ctx.strokeRect(box.xmin, box.ymin, box.xmax - box.xmin, box.ymax - box.ymin);
            ctx.fillText(box.class, box.xmin + 5, box.ymin + 20);
          }
          imagePreview.parentNode.replaceChild(imagePreview);*/

          }else if (data.className) {
          results.innerText = `predictedClassIndex: ${data.className}% `;
          }
        
        }; //load
          
      }); //submit
      

    </script>
  </body>
</html>
